# - Package imports
require('cdAFLAPI')
require('fresh')
require('shiny')
require('shinyWidgets')
require('shinydashboard')
require('shinydashboardPlus')
require('tidyverse')
require('reactable')
require('reactablefmtr')

# Colour theme from fresh::() to style app
colourTheme <- fresh::create_theme(          
  adminlte_color(
    light_blue = "#707070"
  ),
  adminlte_sidebar(
    width         = "200px",
    dark_bg       = "#707070",
    dark_hover_bg = "#ED1C1A",
    dark_color    = "#c6c6c5" 
  ),
  adminlte_global(
    content_bg  = "#FFF",
    box_bg      = "#D8DEE9", 
    info_box_bg = "#D8DEE9"
  ) 
)

# User Credentials
#api_un <- ""
#api_pw <- ""

# Variable for how many seconds between the app refreshing when match is live 
refreshSeconds <- 30

# Environment variable (used for testing ie. empty string '' hits production, 'sandbox' will hit sandbox environment)
environmentVar <- ""

# Fixture (loaded once on app launch)
# Note: The fixture has been filtered down to AFL matches available in both the Prod & Sandbox (match replay) environments.
#       For more info see: https://docs.api.afl.championdata.com/sandbox-environment/
fixture <- bind_rows(getFixture(2021),getFixture(2023)) %>% filter(match.id %in% c(233040944, 233041024, 266377250, 266587185, 266418211))

# Vector of metric codes of interest to be displayed. Used to hit post endpoint & fed into match_stats() reactiveVal.
preDefinedMetrics <- c("KICK", "HANDBALL", "RANKING_POINTS", "CLEARANCE", "POINTS_EXPECTED", "BEHIND")

# Assemble payload for getSquadStatsPOST() function in app.R
payloadList  <- list(metricCodes = preDefinedMetrics, id = "metrics")
squadPayload <- createPayLoad(endpoint = "squad", payloadList)